
;Resource Edit - DednDave, 10-2011

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        INCLUDE    REdit.inc
        .LIST

;###############################################################################################

INIT_BTN_WIDTH  EQU 73
INIT_BTN_HEIGHT EQU 21

;###############################################################################################

        .DATA

dwPrevID        dd 1000

RegClssTable    dd 3                                          ;register class quantity
                dd szButtonWndClss,COLOR_BTNFACE+1,BtnProc    ;button window class
                dd szTrackWndClss,COLOR_SCROLLBAR+1,TrkProc   ;trackbar window class
;                dd szDialogWndClss,DiaProc                    ;pseudo-dialog window class
                dd szClassName,COLOR_WINDOW+1,WndProc         ;main window class (done last)

MenuTable       dd 4                                          ;main menu item quantity
                dd 3                                          ;File menu item quantity
                dd szSaveAs,IDM_FILE_SAVEAS,MF_STRING         ;'Save As...'
                dd NULL,NULL,MF_SEPARATOR                     ;MFT_SEPARATOR
                dd szExit,IDM_FILE_EXIT,MF_STRING             ;'Exit'
                dd szFileMenu                                 ;'File'
                dd 2                                          ;Edit menu item quantity
                dd szAddButton,IDM_EDIT_ADDBUTTON,MF_STRING   ;'Add Button'
                dd szAddTrackBar,IDM_EDIT_ADDTRACK,MF_STRING  ;'Add TrackBar'
                dd szEditMenu                                 ;'Edit'
                dd 1                                          ;View menu item quantity
                dd szSelectFont,IDM_VIEW_FONT,MF_STRING       ;'SelectFont'
                dd szViewMenu                                 ;'View'
                dd 3                                          ;Help menu item quantity
                dd szHelpMenu,IDM_HELP_HELP,MF_STRING         ;'Help'
                dd NULL,NULL,MF_SEPARATOR                     ;MFT_SEPARATOR
                dd szAbout,IDM_HELP_ABOUT,MF_STRING           ;'About'
                dd szHelpMenu                                 ;'Help'

szAppName       db 'Resource Edit',0
szClassName     db 'ResourceEditClass',0
szButtonWndClss db 'ButtonWndClass',0
szTrackWndClss  db 'TrackbarWndClass',0
szButtonClass   db 'Button',0
szSliderClass   db 'msctls_trackbar32',0
szFileMenu      db 'File',0
szSaveAs        db 'Save As...',0
szExit          db 'Exit',0
szEditMenu      db 'Edit',0
szAddButton     db 'Add Button',0
szAddTrackBar   db 'Add TrackBar',0
szViewMenu      db 'View',0
szSelectFont    db 'Select Font',0
szHelpMenu      db 'Help',0
szAbout         db 'About',0
szAboutText     db 'Resource Edit',10
                db 'Copyright ',169,' 2011 David R. Sheldon'
szNullStr       db 0
szHelpText      db 'Help is on the way! ;)',0
szStbMessage    db 'X:      Y:     ',0
szFileTypes     db 'Text Files',0,'*.txt',0,'All Files',0,'*.*',0,0

;------------------------------

        .DATA?

        ALIGN   4

hInstance       dd ?
hHeap           dd ?
hMenu           dd ?
hIcon           dd ?
hWin            dd ?
hStatus         dd ?
dwStbHeight     dd ?
dwScreenWidth   dd ?
dwScreenHeight  dd ?
dwFrameWidth    dd ?
dwFrameHeight   dd ?

cpt POINT <>
; x   dd ?
; y   dd ?

cwr             RECT <>
ccr             RECT <>
; left            dd ?
; top             dd ?
; right           dd ?
; bottom          dd ?

mws      MoveWin <>
; pt       POINT <>
;   x        dd ?
;   y        dd ?
; dwWidth  dd ?
; dwHeight dd ?

ncm              NONCLIENTMETRICS <>
; cbSize           dd ?
; iBorderWidth     dd ?
; iScrollWidth     dd ?
; iScrollHeight    dd ?
; iCaptionWidth    dd ?
; iCaptionHeight   dd ?
; lfCaptionFont    LOGFONT <>
; iSMCaptionWidth  dd ?
; iSMCaptionHeight dd ?
; lfSMCaptionFont  LOGFONT <>
; iMenuWidth       dd ?
; iMenuHeight      dd ?
; lfMenuFont       LOGFONT <>
; lfStatusFont     LOGFONT <>
; lfMessageFont    LOGFONT <>
;   lfHeight         dd ?
;   lfWidth          dd ?
;   lfEscapement     dd ?
;   lfOrientation    dd ?
;   lfWeight         dd ?
;   lfItalic         db ?
;   lfUnderline      db ?
;   lfStrikeOut      db ?
;   lfCharSet        db ?
;   lfOutPrecision   db ?
;   lfClipPrecision  db ?
;   lfQuality        db ?
;   lfPitchAndFamily db ?
;   lfFaceName       db LF_FACESIZE dup(?) ;LF_FACESIZE = 32

;###############################################################################################

        .CODE

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,uMsg
        cmp     ecx,WM_MOUSEMOVE
        jz      ShwPos

        cmp     ecx,WM_SIZE
        jz      SizWin

        cmp     ecx,WM_COMMAND
        jz      Cmmnd0

        cmp     ecx,WM_CREATE
        jz      Create

        cmp     ecx,WM_CLOSE
        jz      WndPrY

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

DefWPr: pop     ebp
        JMP     DefWindowProc

;------------------------------

WndPr0: xor     eax,eax
        ret

;------------------------------

ShwPos: call    CursPos
        jmp     WndPr0

;------------------------------

;WM_SIZE

SizWin: INVOKE  GetClientRect,hWnd,offset cwr
        mov     eax,cwr.bottom
        mov     edx,dwStbHeight
        sub     eax,edx
        mov     cwr.bottom,eax
        INVOKE  MoveWindow,hStatus,0,eax,cwr.right,edx,TRUE
        jmp     WndPr0

;------------------------------

;WM_COMMAND

Cmmnd0: mov     eax,wParam
        cmp     eax,IDM_FILE_SAVEAS
        jz      FSave0

        cmp     eax,IDM_FILE_EXIT
        jz      FExit0

        cmp     eax,IDM_EDIT_ADDBUTTON
        jz      AddBtn

        cmp     eax,IDM_EDIT_ADDTRACK
        jz      AddTrk

        cmp     eax,IDM_VIEW_FONT
        jz      ChFont

        cmp     eax,IDM_HELP_HELP
        jz      HlpHlp

        cmp     eax,IDM_HELP_ABOUT
        jnz     DefWPr

;------------------------------

;WM_COMMAND, IDM_HELP_ABOUT

        INVOKE  ShellAbout,hWnd,offset szNullStr,offset szAboutText,hIcon
        jmp     WndPr0

;------------------------------

;WM_COMMAND, IDM_FILE_SAVEAS

FSave0: push    esi
        push    edi
        call    FnAlloc
        push    eax                                                      ;HFree:hBlck
        push    edx
        push    eax

        push    ecx                                                      ;lpTemplateName
        push    ecx                                                      ;lpfnHook
        push    ecx                                                      ;lCustData
        push    offset szFileTypes+13                                    ;lpstrDefExt - 'txt',0
        push    ecx                                                      ;nFileOffset/nFileExtension
        push    OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_OVERWRITEPROMPT ;Flags or OFN_ENABLEHOOK or OFN_EXPLORER
        push    offset szSaveAs                                          ;lpstrTitle
        push    ecx                                                      ;lpstrInitialDir
        push    ecx                                                      ;nMaxFileTitle
        push    ecx                                                      ;lpstrFileTitle
        push    edx                                                      ;nMaxFile
        push    eax                                                      ;lpstrFile
        push    1                                                        ;nFilterIndex
        push    ecx                                                      ;nMaxCustFilter
        push    ecx                                                      ;lpstrCustomFilter
        push    offset szFileTypes                                       ;lpstrFilter
        push    hInstance                                                ;hInstance
        push    hWnd                                                     ;hwndOwner
        push    76                                                       ;lStructSize
        INVOKE  GetSaveFileName,esp
        add     esp,76                                                   ;sizeof OPENFILENAME
        xor     eax,eax
        pop     edx
        pop     ecx
        cmp     al,[edx]
        jz      FSave4

        mov     edi,edx
        repnz   scasb
        sub     edi,5
        cmp dword ptr [edi],'txt.'
        jnz     FSave3

        lea     esi,[edi-1]

FSave1: mov     cl,[esi]
        cmp     cl,'.'
        jz      FSave2

        cmp     cl,'\'
        jz      FSave3

        cmp     cl,':'
        jz      FSave3

        dec     esi
        cmp     esi,edx
        ja      FSave1

        jmp short FSave3

FSave2: mov     [edi],al

;file save code (for the demo, a message box just shows the file name)

FSave3: INVOKE  MessageBox,hWnd,edx,offset szSaveAs,MB_OK

FSave4: CALL    HFree
        pop     edi
        pop     esi
        jmp     WndPr0

;------------------------------

;WM_COMMAND, IDM_FILE_EXIT

FExit0: INVOKE  PostMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,NULL
        jmp     WndPr0

;------------------------------

;WM_COMMAND, IDM_EDIT_ADDBUTTON

AddBtn: INVOKE  CreateWin,offset szButtonWndClss,INIT_BTN_WIDTH,INIT_BTN_HEIGHT

;add code to make a button

        jmp     WndPr0

;------------------------------

;WM_COMMAND, IDM_EDIT_ADDTRACK

AddTrk:

        jmp     WndPr0

;------------------------------

;WM_COMMAND, IDM_VIEW_FONT

ChFont: xor     eax,eax
        push    eax                                    ;CHOOSEFONT.nSizeMax
        push    eax                                    ;CHOOSEFONT.nSizeMin
        push    eax                                    ;CHOOSEFONT.nFontType
        push    eax                                    ;CHOOSEFONT.lpszStyle
        push    eax                                    ;CHOOSEFONT.hInstance
        push    eax                                    ;CHOOSEFONT.lpTemplateName
        push    eax                                    ;CHOOSEFONT.lpfnHook
        push    eax                                    ;CHOOSEFONT.lCustData
        push    eax                                    ;CHOOSEFONT.rgbColors
        push    CF_SCREENFONTS or CF_EFFECTS or CF_INITTOLOGFONTSTRUCT ;CHOOSEFONT.Flags
        push    eax                                    ;CHOOSEFONT.iPointSize
        push    offset ncm.lfMessageFont               ;CHOOSEFONT.lpLogFont
        push    eax                                    ;CHOOSEFONT.hDC
        push    hWnd                                   ;CHOOSEFONT.hwndOwner
        push    sizeof CHOOSEFONT                      ;CHOOSEFONT.lStructSize
        INVOKE  ChooseFont,esp
        add     esp,sizeof CHOOSEFONT
        jmp     WndPr0

;------------------------------

;WM_COMMAND, IDM_HELP_HELP

HlpHlp: INVOKE  MessageBox,hWnd,offset szHelpText,offset szAppName,MB_OK
        jmp     WndPr0

;------------------------------

;WM_CREATE

Create: push    ebx
        mov     ebx,hWnd

;create status bar

        INVOKE  CreateStatusWindow,WS_CHILD or WS_VISIBLE,offset szStbMessage,ebx,CID_STATUSBAR
        mov     hStatus,eax

;get and store status bar height

        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,eax,esp
        pop     eax                                    ;left
        pop     edx                                    ;EDX = top
        pop     ecx                                    ;right
        pop     eax                                    ;EAX = bottom
        sub     eax,edx                                ;EAX = bottom-top = height
        mov     dwStbHeight,eax

;store hWnd in hWin and exit to OS

        mov     hWin,ebx
        pop     ebx
        jmp     WndPr0

;------------------------------

;WM_CLOSE

WndPrY: INVOKE  DestroyWindow,hWnd
        jmp     WndPr0

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

;------------------------------

WndProc ENDP

;***********************************************************************************************

        ALIGN   16

BtnProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     ecx,uMsg
        cmp     ecx,WM_MOUSEMOVE
        jz      CmMove

        cmp     ecx,WM_NCMOUSEMOVE
        jz      NmMove

        cmp     ecx,WM_SIZE
        jz      wmSize

        cmp     ecx,WM_LBUTTONDOWN
        jz      LftBtn

        cmp     ecx,WM_LBUTTONUP
        jz      LftBUp

        cmp     ecx,WM_NCLBUTTONDOWN
        jz      NOnTop

;------------------------------------

;exit, default window proc

DefPrc: pop     ebp
        JMP     DefWindowProc

;------------------------------------

;WM_MOUSEMOVE, mouse move, client area

CmMove: call    CursPos
        jz      ExitR0

        test byte ptr wParam,1
        jz      ExitR0

        mov     edx,offset mws
        add     ecx,[edx].MoveWin.pt.y
        add     eax,[edx].MoveWin.pt.x

;        INVOKE  MoveWindow,hWnd,eax,ecx,[edx].MoveWin.dwWidth,[edx].MoveWin.dwHeight,TRUE

        INVOKE  SetWindowPos,hWnd,HWND_TOP,eax,ecx,[edx].MoveWin.dwWidth,[edx].MoveWin.dwHeight,SWP_SHOWWINDOW

;------------------------------------

;exit, return 0

ExitR0: xor     eax,eax
        ret

;------------------------------------

;WM_NCMOUSEMOVE, mouse move, non-client area

NmMove: call    CursPos
        jmp     DefPrc

;------------------------------------

;WM_SIZE

wmSize: call    CursPos
        jmp     ExitR0

;------------------------------------

;WM_LBUTTONDOWN, left button down, client area

LftBtn: INVOKE  OnTop,hWnd

;translate the client coordinates in cwr to screen coordinates in ccr

        mov     edx,offset ccr.right
        mov     eax,cwr.right
        mov     ecx,cwr.bottom
        mov     [edx].POINT.x,eax
        mov     [edx].POINT.y,ecx
        INVOKE  ClientToScreen,hWin,edx
        mov     edx,offset ccr.left
        xor     eax,eax
        mov     [edx].POINT.x,eax
        mov     [edx].POINT.y,eax
        INVOKE  ClientToScreen,hWin,edx

;fill a temporary RECT with child window screen coordinates

        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,hWnd,esp

;translate the upper left window coordinates to main window client coordinates

        push    [esp].POINT.y
        push    [esp+4].POINT.x
        INVOKE  ScreenToClient,hWin,esp

;get the current cursor position in main window client coordinates

        push    ecx
        push    eax
        INVOKE  GetCursorPos,esp
        INVOKE  ScreenToClient,hWin,esp
        pop     edx
        pop     ecx

;store the upper left corner coordinates, less the current cursor coordinates (for mouse move)

        pop     eax
        sub     eax,edx
        mov     edx,offset mws
        mov     [edx].MoveWin.pt.x,eax
        pop     eax
        sub     eax,ecx
        mov     [edx].MoveWin.pt.y,eax

;store the width and height of the child window (for mouse move)

        mov     ecx,[esp].RECT.right
        mov     eax,[esp].RECT.bottom
        sub     ecx,[esp].RECT.left
        sub     eax,[esp].RECT.top
        mov     [edx].MoveWin.dwWidth,ecx
        mov     [edx].MoveWin.dwHeight,eax

;fill a temporary POINT structure with cursor screen coordinates

        sub     esp,sizeof POINT
        INVOKE  GetCursorPos,esp

;adjust the ccr rectangle for clipping

        pop     eax                        ;EAX = cursor X position
        mov     edx,[esp+4].RECT.right
        dec     edx
        sub     edx,eax
        sub     eax,[esp+4].RECT.left
        sub     ccr.right,edx
        add     ccr.left,eax

        pop     eax                        ;EAX = cursor Y position
        mov     edx,[esp].RECT.bottom
        dec     edx
        sub     edx,eax
        sub     eax,[esp].RECT.top
        sub     ccr.bottom,edx
        add     ccr.top,eax

;discard the temporary RECT

        add     esp,sizeof RECT

;set the clip rectangle

        INVOKE  ClipCursor,offset ccr
        jmp     ExitR0

;------------------------------------

;WM_LBUTTONUP, left button up, client area

LftBUp: INVOKE  ClipCursor,NULL
        jmp     ExitR0

;------------------------------------

;WM_LBUTTONDOWN, left button down, non-client area

NOnTop: INVOKE  OnTop,hWnd
        jmp     DefPrc

BtnProc ENDP

;***********************************************************************************************

        ALIGN   16

TrkProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        pop     ebp
        JMP     DefWindowProc

TrkProc ENDP

;***********************************************************************************************

CreateWin PROC uses ESI EDI lpszClassName:LPCTSTR,nWidth:UINT,nHeight:UINT

        mov     ecx,dwFrameWidth
        mov     edx,dwFrameHeight
        shl     ecx,1
        shl     edx,1
        inc dword ptr dwPrevID
        push    ecx
        push    edx
        mov     esi,cwr.right
        mov     edi,cwr.bottom
        add     ecx,nWidth
        add     edx,nHeight
        cmp     ecx,esi
        jbe     CrWin0

        mov     ecx,esi

CrWin0: cmp     edx,edi
        jbe     CrWin1

        mov     edx,edi

CrWin1: sub     esi,ecx
        sub     edi,edx
        shr     esi,1
        shr     edi,1
        push    ecx
        push    edx
        INVOKE  CreateWindowEx,NULL,lpszClassName,offset szAppName,
                WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS,
                esi,edi,ecx,edx,hWin,dwPrevID,hInstance,NULL
        push    eax
        INVOKE  OnTop,eax
        pop     eax
        pop     edx
        pop     ecx
        pop     edi
        pop     esi
        sub     edx,edi
        sub     ecx,esi
        ret

CreateWin ENDP

;***********************************************************************************************

OnTop   PROC    uses EBX ESI hWnd:HWND

        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,hWnd,esp
        pop     esi
        pop     ebx
        push    ebx
        push    esi
        INVOKE  ScreenToClient,hWin,esp
        pop     ecx
        pop     edx
        pop     eax
        sub     eax,esi
        pop     esi
        sub     esi,ebx
        INVOKE  SetWindowPos,hWnd,HWND_TOP,ecx,edx,eax,esi,SWP_SHOWWINDOW
        ret

OnTop   ENDP

;***********************************************************************************************

FnAlloc PROC

;allocate temporary buffer for filenames

;  Returns: EAX = address of allocated block
;           ECX = 0
;           EDX = size of allocated block

        mov     edx,4096
        push    edx
        INVOKE  HeapAlloc,hHeap,HEAP_ZERO_MEMORY,edx
        xor     ecx,ecx
        pop     edx
        ret

FnAlloc ENDP

;***********************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

HFree   PROC    hBlock:HANDLE

;frees heap allocation

        pop     edx
        push    NULL
        push    hHeap
        push    edx
        JMP     HeapFree

HFree   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

CursPos PROC

;  Returns: EAX = cursor X position, main window client coordinates
;           ECX = cursor Y position, main window client coordinates
;           ZF  = TRUE if no cursor position change from previous call

        push    ecx
        push    eax
        INVOKE  GetCursorPos,esp
        INVOKE  ScreenToClient,hWin,esp
        pop     eax
        mov     edx,offset cpt
        pop     ecx
        cmp     eax,[edx].POINT.x
        jnz     CurPs0

        cmp     ecx,[edx].POINT.y
        jz      CurPs1

CurPs0: push    ebx
        push    ecx
        mov     [edx].POINT.x,eax
        push    eax
        push    ecx
        mov     [edx].POINT.y,ecx
        call    B2As4
        pop     eax
        mov dword ptr szStbMessage+3,ecx
        call    B2As4
        mov dword ptr szStbMessage+11,ecx
        INVOKE  SendMessage,hStatus,SB_SETTEXT,0,offset szStbMessage
        pop     eax
        or      dl,1
        pop     ecx
        pop     ebx

CurPs1: ret

CursPos ENDP

;***********************************************************************************************

B2As4   PROC

;converts binary values from 0 to 9999 to ASCII
;uses EBX

        mov     edx,4294968          ;2^32/1000
        mov     ebx,10               ;per digit
        mul     edx                  ;extend first digit
        mov     ecx,edx              ;digit 1 in CL
        mul     ebx                  ;second digit
        mov     ch,dl                ;digit 2 in CH
        mul     ebx                  ;third digit
        bswap   ecx                  ;digits 1 & 2 up high
        mov     ch,dl                ;digit 3 in CH
        mul     ebx                  ;digit 4 in DL
        lea     ecx,[edx+ecx+'0000'] ;combine and make ASCII
        bswap   ecx                  ;re-order bytes
        cmp     cl,30h
        jnz     B2As42

        cmp     ch,30h
        jnz     B2As41

        test    ecx,0F0000h
        jnz     B2As40

        and     ecx,03F202020h
        ret

B2As40: mov     cx,2020h
        ret

B2As41: mov     cl,20h

B2As42: ret

B2As4   ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx

;------------------------------

;initialize hHeap

        INVOKE  GetProcessHeap
        mov     hHeap,eax

;------------------------------

;initialize system metrics

        INVOKE  GetSystemMetrics,SM_CXSCREEN
        mov     dwScreenWidth,eax
        INVOKE  GetSystemMetrics,SM_CYSCREEN
        mov     dwScreenHeight,eax
        INVOKE  GetSystemMetrics,SM_CXSIZEFRAME
        mov     dwFrameWidth,eax
        INVOKE  GetSystemMetrics,SM_CYSIZEFRAME
        mov     dwFrameHeight,eax

;initialize NONCLIENTMETRICS structure (to get user defined fonts)

        push    sizeof NONCLIENTMETRICS
        mov     edx,offset ncm
        pop     ecx
        mov     [edx].NONCLIENTMETRICS.cbSize,ecx
        INVOKE  SystemParametersInfo,SPI_GETNONCLIENTMETRICS,ecx,edx,edi

;------------------------------

;create the main menu

        INVOKE  CreateMenu
        xchg    eax,ebx                                 ;EBX = hMenu
        mov     esi,offset MenuTable
        lodsd
        mov     hMenu,ebx
        xchg    eax,edi                                 ;EDI = main menu item qty

MMenu0: INVOKE  CreatePopupMenu
        push    eax
        lodsd
        xchg    eax,ebp

MMenu1: pop     edx
        lodsd
        push    edx
        push    eax
        lodsd
        push    eax
        lodsd
        push    eax
        push    edx
        CALL    AppendMenu
        dec     ebp
        jnz     MMenu1

        lodsd
        pop     edx
        INVOKE  AppendMenu,ebx,MF_POPUP,edx,eax
        dec     edi
        jnz     MMenu0

;------------------------------

;register the window classes

        push    ebx
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        xchg    eax,ebp                                 ;EBP = hInstance

        INVOKE  LoadIcon,ebp,IDI_ICON
        mov     hIcon,eax

        INVOKE  LoadCursor,edi,IDC_ARROW
        xchg    eax,ebx                                 ;EBX = hCursor
        mov     esi,offset RegClssTable
        lodsd
        xchg    eax,ecx                                 ;ECX = loop count

ClReg0: lodsd                                           ;EAX = lpszClassName
        push    ecx                                     ;save loop count
        push    eax                                     ;save lpszClassName

        push    hIcon                                   ;WNDCLASSEX.hIconSm
        push    eax                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        lodsd                                           ;EAX = hbrBackground
        push    eax                                     ;WNDCLASSEX.hbrBackground
        push    ebx                                     ;WNDCLASSEX.hCursor
        push    hIcon                                   ;WNDCLASSEX.hIcon
        lodsd                                           ;EAX = lpfnWndProc
        push    ebp                                     ;WNDCLASSEX.hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    eax                                     ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp
        add     esp,sizeof WNDCLASSEX

        pop     edx                                     ;recall lpszClassName
        pop     ecx                                     ;recall loop count
        loop    ClReg0

        pop     ebx

;------------------------------

;create the main window

        INVOKE  CreateWindowEx,edi,edx,offset szAppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,
                CW_USEDEFAULT,SW_SHOWNORMAL,600,450,edi,ebx,ebp,edi
        INVOKE  UpdateWindow,eax

;------------------------------

;message loop

        pushad                                          ;create stack space for MSG struct
        mov     ebp,esp                                 ;EBP = offset MSG struct
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop1: INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                     ;exit only
        shr     eax,1                                   ;if 0 or -1
        jnz     mLoop0                                  ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                     ;MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

